DAEMON(8)

NAME
daemon - run detached from the controlling terminal

SYNOPSIS
daemon [-cfr] [-p child_pidfile] [-P supervisor_pidfile] [-t title] [-u user] command arguments ...

DESCRIPTION
The daemon utility detaches itself from the controlling terminal and executes the program specified by its arguments. Privileges may be lowered to the specified user.

The options are as follows:

-c  Change the current working directory to the root (“/”).

-f  Redirect standard input, standard output and standard error to /dev/null.

-p child_pidfile
    Write the ID of the created process into the child_pidfile using the pidfile(3) functionality. The program is executed in a spawned child process while the daemon waits until it terminates to keep the child_pidfile locked and removes it after the process exits. The child_pidfile owner is the user who runs the daemon regardless of whether the -u option is used or not.

-P supervisor_pidfile
    Write the ID of the daemon process into the supervisor_pidfile using the pidfile(3) functionality. The program is executed in a spawned child process while the daemon waits until it terminates to keep the supervisor_pidfile locked and removes it after the process exits. The supervisor_pidfile owner is the user who runs the daemon regardless of whether the -u option is used or not.

-r  Supervise and restart the program if it has been terminated.

-t title
    Process title for the daemon to make it easily identifiable.

-u user
    Login name of the user to execute the program under. Requires adequate superuser privileges.

If the -p, -P or -r option is specified the program is executed in a spawned child process. The daemon waits until it terminates to keep the pid file(s) locked and removes them after the process exits or restarts the program. In this case if the monitoring daemon receives software termination signal (SIGTERM) it forwards it to the spawned process. Normally it will cause the child to exit, remove the pidfile(s) and then terminate.

The -P option is useful combined with the -r option as supervisor_pidfile contains the ID of the supervisor not the child. This is especially important if you use -r in an rc script as the -p option will give you the child's ID to signal when you attempt to stop the service, causing daemon to restart the child.

EXIT STATUS
The daemon utility exits 1 if an error is returned by the daemon(3) library routine, 2 if child_pidfile or supervisor_pidfile is requested, but cannot be opened, 3 if process is already running (pidfile exists and is locked), otherwise 0.

DIAGNOSTICS
If the command cannot be executed, an error message is displayed on standard error unless the -f flag is specified.

SEE ALSO
setregid(2), setreuid(2), daemon(3), exec(3), pidfile(3), termios(4), tty(4)

HISTORY
The daemon utility first appeared in FreeBSD 4.7.